/* Created by Anjuta version 1.0.1 */
/*	This file will not be overwritten */
#include "../include/main.h"

void usage ()
{
	cout << " Usage:" << endl;
	cout << "	generating key: rsa [-g[-u fname][-r fname]]" << endl;
	cout << " crypting:       rsa [[-c][-k kfile][-m mfile][-o ofile][-b base]]" <<
		endl;
	cout << endl;
	cout << " Global options:" << endl;
	cout << " -h			This helpfull text" << endl;
	cout << " Key generating options:" << endl;
	cout << " -g 		  	Generate RSA key pair" << endl;
	cout << " -u	fname 	pUblic key filename [default: public.key]" <<
		endl;
	cout << " -r	fname	pRivate key filename [default: private.key]"
		<< endl;
	cout << " -b	size	key size in Bits [default: 512, min: 128]" <<
		endl;
	cout << " Enrypting/Decrypting:" << endl;
	cout << " -c			Encrypt/decrypt (default)" << endl;
	cout << " -k  kfile   Key filename [default: /dev/stdin]" << endl;
	cout << " -m  mfile   Message filename [default: /dev/stdin]" << endl;
	cout << " -o  ofile   Output filename [default: /dev/stdout]" << endl;
	cout << " -b  base 	  input/output number base [default: 16 (hex)]" <<endl;
}

int main (int argc, char **argv)
{
	char opt, optstring[20] = "gcu:r:b:d:hk:m:o:";

	opt = getopt (argc, argv, optstring);
	if (opt == -1)
	{
		usage ();
		exit (1);
	}

	char pubfname[256] = "public.key";
	char prvfname[256] = "private.key";

	char kfile[256] = "/dev/stdin";
	char mfile[256] = "/dev/stdin";
	char ofile[256] = "/dev/stdout";

	int action = ENCRYPT;
	int bits = 512;
	int base = 16;

	while (opt != -1)
	{
		switch (opt)
		{
		case 'g':
			action = GENERATE;
			break;

		case 'c':
			action = ENCRYPT;
			break;

		case 'u':
			strcpy (pubfname, optarg);
			break;

		case 'r':
			strcpy (prvfname, optarg);
			break;

		case 'b':
			bits = atoi (optarg);
			break;

		case 'h':
			usage ();
			exit (0);
			break;

		case 'k':
			strcpy (kfile, optarg);
			break;
		case 'm':
			strcpy (mfile, optarg);
			break;
		case 'o':
			strcpy (ofile, optarg);
			break;

		};
		opt = getopt (argc, argv, optstring);
	};

	if (action == GENERATE)
		keygen (prvfname, pubfname, bits);

	if (action == ENCRYPT)
		crypt(kfile, mfile, ofile, base);
	return (0);
}
